/* L'objectif de cet exercice consiste à implémenter des files FIFO en
 * utilisant une structure sous forme de liste chaînée. Dans cet
 * exercice, l'implémentation de la liste chaînée est fournie, et il
 * n'est demandé que d'implémenter le type de donnée FIFO.
 *
 * Le sujet associé à cet exercice est fourni dans le fichier
 * suivant : https://moodle.bordeaux-inp.fr/mod/resource/view.php?id=17866
 */

/********* DEBUT DU CODE A NE PAS MODIFIER **********************/
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/**
    Les structures de données et l'interface pour créer des
    links/maillons sont données de la manière suivante :
*/

struct lelement {
    int data;
    struct lelement * next;
};

struct link {
    struct lelement * head;
    struct lelement * tail;
};

/**
    Les fonctions suivantes sont déjà implémentées et ne font pas
    partie de l'exercice.
*/
struct link lnk__empty(void);
void lnk__add_head(struct link *, struct lelement *);
struct lelement * lnk__remove_head(struct link *);
void lnk__add_tail(struct link *, struct lelement *);
struct lelement * lnk__remove_tail(struct link *);
int lnk__is_end_mark(struct link const *, struct lelement const *);

/**
   La structure fifo est imposée. Si vous la modifiez, les test
   peuvent ne plus passer.
*/

struct fifo {
    struct link * list;
};

/**
   Vous disposez d'une fonction print_fifo(void const struct fifo*)
   pour vos tests.
*/
/********** FIN DU CODE A NE PAS MODIFIER ***********************/

/**
   Implémenter l'ensemble des fonctions suivantes :
*/

struct fifo * fifo__empty()
    ;

void fifo__push(struct fifo *f, int x)
    ;

int fifo__is_empty(struct fifo const *f)
    ;

int fifo__top(struct fifo const *f)
    ;

void fifo__pop(struct fifo *f)
    ;

void fifo__free(struct fifo *f)
    ;

int main(void) {
  printf("Add your own tests here\n");
}
